
import requests
import json
from datetime import datetime, timedelta
import hashlib
import numpy as np

name='jesse'
inputpass='kpl..87788'


# ʱ
daytime = input('ڸʽ --գ')
print('Ľ:', daytime)

token=''
# Ϣmap
carinfoMap={}
# ̺ʱ
carLineTimerMap={}
# ƽֳ̨
carIncomeScaleMap={}
# Ϣİid
user_idArry=[]
userInfoBindMap={}
# ˾İ
CompaniesMap={}
# ͳƵȫϢ
StatisticsAllInfo=[]
# ͳƵϢ
StatisticsOverview={}

# ģ¼ ֹtoken仯޷
def login():
    
    a=datetime.now() - timedelta(hours=8)
    n=sha256_hash(name+','+inputpass)
    key_login=sha256_hash(n+','+a.strftime('%Y-%m-%d'))
    print(key_login)
    data={
     'req_param':{
     'key_login':key_login,
     'name':name,
     'client_time':a.strftime('%Y-%m-%d %H:%M:%S')
     },
     'task':1002,
     'task_num':1
    }
    res=obtain_server_data('1002-1','login',data)
    return res['token']

#»Ծ,췢,ջԾ
def monthNumerAndDevices():
    data={
        'req_param':{
            'system_role': '1'
        },
        'task': 5003,
        'task_num': 15,
        'token':token
        }
    
    res=obtain_server_data('5003-15','jp_query_system_view',data)   
    dev=res['devies']
    return dev['devices_active_month'],dev['devices'],dev['devices_active_today']
  
# ѧԱ,û˾
def stuAndCoachNumber():
    data={
        'req_param':{
        },
        'task': 1002,
        'task_num': 103,
        'token':token
        }
    
    res=obtain_server_data('1002-103','query_jp_user_count',data)  
    
    return  int(res['stu_total']),int(res['coach_total']),int(res['coach_total'])+int(res['stu_total'])

# ֵ¼ ֧ 뿪  
def recharge_record_statistics(type):
    statTime,endTime=time_convert(type)
    print (statTime,endTime)
    data={
        'req_param':{
           'begin':0,
            'limit': '10',
            'system_role': '1',
           'condition':{
              'date__begin': statTime,
              'date__end':endTime
           },
           'state':[1]
        },
        'task': 5005,
        'task_num': 7,
        'token':token
        }
    
    res=obtain_server_data('5005-7','jp_query_charge_record',data)
    #   
    ordersNum=res['amount']
    print (ordersNum)
    # 
    kpl_income=round(float(res['earning_producer'])/100,2)
    print (kpl_income)
    # 
    facilitator_income=round(float(float(res['earning_agent'])+float(res['earning_bind_coach']))/100,2)
    print (facilitator_income)
    # 
    coach_income=round(float(res['earning_login_coach'])/100,2)
    print (coach_income)
    # ܶ 
    total_income=coach_income+facilitator_income+kpl_income
 
    return ordersNum,kpl_income,facilitator_income,coach_income,total_income

# ˳Ϣ
def carInfoFiltration():
    data={
        'req_param':{
           'column':['sn','hphm','date_bind_coach','id_bind_coach','id_company','id_agent','id_agent2'],
           'condition':{
           },
        },
        'task': 5001,
        'task_num': 1,
        'token':token
        }
    
    res=obtain_server_data('5001-1','jp_query_car',data)
    for row in res['result']:
        if len( row['id_bind_coach'] )>0:
           carinfoMap[row['sn']]={
               'date_bind_coach':row['date_bind_coach'],
               'hphm':row['hphm'],
               'id_company':row['id_company'],
               # ̰id
               'id_agent':row['id_agent'],
               # ˾󶨵id
               'id_agent2':row['id_agent2'],
               # 󶨵id
               'id_bind_coach':row['id_bind_coach']
           }
           user_idArry.append(row['id_bind_coach'])
 
       
# 
def carLineNumAndTimer(type):
    statTime,endTime=time_convert(type)
    data={
        'req_param':{
           'condition':{
              'date__begin': statTime,
              'date__end':endTime,
              'group':'sn'
           },
           'group':'sn',
           'system_role':'1'
        },
        'task': 5003,
        'task_num': 9,
        'token':token
        }
    res=obtain_server_data('5003-9','jp_query_mileage_count',data)
    for row in res['result']: 
        carLineTimerMap[row['sn']]={
            'lc': round( float(row['lc'])/1000,2),
            'seconds': round( float(row['seconds'])/3600,2)
        }
    
# ƽֳ̨
def carIncomeAndScale(type):
    statTime,endTime=time_convert(type)
    data={
        'req_param':{
           'condition':{
              'date__begin': statTime,
              'date__end':endTime,
              'group':'sn'
           },
           'group':'sn',
           'system_role':'1'
        },
        'task': 5005,
        'task_num': 21,
        'token':token
        }
    res=obtain_server_data('5005-21','jp_count_benefit',data)
    for row in res['result']: 
        carIncomeScaleMap[row['sn']]={
            'money': round( float(row['money'])/100,2),
            # ƽֳ̨
            'earning_producer': round(float(row['earning_producer'])/100,2),
            # ̷ֳ
            'earning_agent': round(float(row['earning_agent'])/100,2),
            # 󶨽ֳ
            'earning_bind_coach': round(float(row['earning_bind_coach'])/100,2),
            # ¼ֳ
            'earning_login_coach': round(float(row['earning_login_coach'])/100,2)
        }


# ȡ󶨵ûϢ
def getCarinfo():
    # ȥأȡظ
    new_list = []
    for i in user_idArry:
        if i not in new_list:
            new_list.append(i)
    data={
        'req_param':{
           'page':1,
           'per_page_count':len(new_list),
           'user_ids':new_list
        },
        'task': 1002,
        'task_num': 13,
        'token':token
        }
    res=obtain_server_data('1002-13','query_users',data)
    # ذ󶨸ʽ  ֵԵʽ
    for idx,id in enumerate(new_list) : 
        row=res['users'][idx]
        userInfoBindMap[id]={
            'name':row['real_name'],
            'tel':row['telephone'],
        }

# ȡȫ˾id
def getCompaniesId():
    data={
        'req_param':{
        },
        'task': 1002,
        'task_num': 21,
        'token':token
    } 
    res=obtain_server_data('1002-21','query_companies',data)
    # ذ󶨸ʽ  ֵԵʽ
    for row in res['companies']: 
        CompaniesMap[row['id']]={
            # Ӧֵ
            'parent_list':row['parent_list'],
            # ˾
            'name':row['name']
        }
        
    
    
# 󷽷
def obtain_server_data(api_id,api_name,data):
    url = f'https://j.kplzj.com/api/request?n={api_id}&api={api_name}'  # 滻ΪҪPOSTURL
    print(url)
    # POST
    proxies = {
        'http': None,
        'https': None,
    }
    response = requests.post(url,proxies=proxies, verify=False, data=json.dumps(data,ensure_ascii=False))
    # Ƿɹ
    if response.status_code == 200:
        res= json.loads(response.text)
        if res['state']==0:
            print('POSTɹ')
            return res
    else:
        print('POSTʧܣ״̬룺', response.status_code)
        print('Ϣ', response.text)
    return


# 洢ӿ
def updata_server(api_id,data):
    url = f'http://119.96.145.175:12103/api/smart/save/{api_id}'

    
    
    response = requests.post(url, data=json.dumps(data))
    # Ƿɹ
    if response.status_code == 200:
        res= json.loads(response.text)
        if res['code']==0:
            print('³ɹ')
            return res
    else:
        print('POSTʧܣ״̬룺', response.status_code)
        print('Ϣ', response.text)
    return

# ʱʽת
def time_convert(type):
    # ȡǰںʱ
    current_datetime = datetime.strptime(daytime,'%Y-%m-%d')
    if type=='day':
        startTime = current_datetime.strftime('%Y-%m-%d')
        endTime=current_datetime.strftime('%Y-%m-%d')
    elif type=='month':
        startTime = current_datetime.strftime('%Y-%m-01')
        endTime=current_datetime.strftime('%Y-%m-%d')
    elif type=='all':
        startTime = '2023-05-01'
        endTime=current_datetime.strftime('%Y-%m-%d')
    return startTime,endTime


# ʱ
def time_diff(start_time_str,end_time_str ):
    # ַתΪdatetime
    start_time = datetime.strptime(start_time_str, '%Y-%m-%d')
    end_time = datetime.strptime(end_time_str, '%Y-%m-%d')

    # ʱtimedelta
    time_difference = end_time - start_time

    # timedeltaлȡ
    days_difference = time_difference.days
    return days_difference


# sha256
def sha256_hash(input_string):
    # ַתΪUTF-8
    input_bytes = input_string.encode('utf-8')
    
    # SHA-256ϣ
    sha256_hash_object = hashlib.sha256()
    
    # ¹ϣԴֽ
    sha256_hash_object.update(input_bytes)
    
    # ȡʮƱʾĹϣ
    hashed_string = sha256_hash_object.hexdigest()
    
    return hashed_string


if __name__ == '__main__':
    
    
    #ȡtoken
    token=login()

    # »Ծ,췢,ջԾ
    month_total,dev_total,day_total=monthNumerAndDevices()

    # # ѧԱ,û
    stu_total,coach_total,stucoach_total=stuAndCoachNumber()

    # ¶뿪գ̣֧ܶ
    month_ordersNum,_,_,_,_ = recharge_record_statistics('month')
    # ȫ
    all_ordersNum,_,_,_,_ = recharge_record_statistics('all')

    # 충뿪գ̣֧ܶ
    day_ordersNum,day_kpl_income,day_facilitator_income,day_coach_income,day_income=recharge_record_statistics('day')
    
    # ͳ:֧/Ծ
    # ƽ 
    print (day_income,day_total)
    car_output=round(float(day_income)/float(day_total) ,2)
    print (car_output)
    # ƽ-
    kpl_car_output=round(float(day_kpl_income)/float(day_total),2)
    
    # ƽ-
    facilitator_car_output=round(float(day_facilitator_income)/float(day_total),2)
    
    # ƽ-
    coach_car_output=round(float(day_coach_income)/float(day_total),2)
    
    # ֳɱ:
    # ʵʱֳɱ
    kpl_scale=f'{round(float(day_kpl_income)/float(day_income),2)}%' 
    # ʵʱֳɱ
    facilitator_scale=f'{round(float(day_facilitator_income)/float(day_income),2)}%'
    # ʵʱֳɱ
    coach_scale=f'{round(float(day_coach_income)/float(day_income),2)}%'
    

    ################################################################################################################
    # # ˳Ϣ
    carInfoFiltration()
    
    # # 
    carLineNumAndTimer('all')
    
    # # ƽֳ̨
    carIncomeAndScale('all')
    
    # ȡ󶨵ûϢ
    getCarinfo()
    
    # ȡ˾󶨵Ϣ
    getCompaniesId()
    
    
    # 峵׼ /
    # װ 
    ckd_Num=0
    ckd_Ratio=None
    # 공 
    cbev_Num=0
    cbev_Ratio=None
    # ʬ
    av_Num=0
    av_Ratio=None
    # ˯
    lsv_Num=0
    lsv_Ratio=None
    # Ͳ 
    lcv_Num=0
    lcv_Ratio=None   
    # 
    alltotal=len(carinfoMap)
    #հװ
    todayalltotal=0
    
    

    
    
    for sn in carinfoMap:
      # Ϣid
        id_agent=carinfoMap[sn]['id_agent']
        # ˾Ϣid
        id_agent2=carinfoMap[sn]['id_agent2']
        # ûid
        id_company=carinfoMap[sn]['id_company']
        # 󶨵id
        id_bind_coach=carinfoMap[sn]['id_bind_coach']
        
        
        #############Ҫϴ
        # 
        date_bind_coach=carinfoMap[sn]['date_bind_coach']
        #  sn
        
        # 
        hphm=carinfoMap[sn]['hphm']
        # 
        username=userInfoBindMap[id_bind_coach]['name']
        # 绰 
        tel=userInfoBindMap[id_bind_coach]['tel']
        # ˾
        if len(id_agent2)>0:
            companyName=CompaniesMap[int(id_agent2)]['name']
        else:
            companyName=''
        # 
        agentName = CompaniesMap[int(id_agent)]['name']
        
        
        
        if sn in carLineTimerMap:
            # 
            lc= carLineTimerMap[sn]['lc']
            # ʱ
            seconds= carLineTimerMap[sn]['seconds']
        else:
            lc=0
            seconds=0
        if sn in carIncomeScaleMap:
            # 
            money= carIncomeScaleMap[sn]['money']
            # ƽֳ̨
            earning_producer= carIncomeScaleMap[sn]['earning_producer']
            e_p=f'{round(float(earning_producer)/float(money)*100,2)}%'
            # ̷ֳ
            earning_agent=carIncomeScaleMap[sn]['earning_agent']
            e_a=f'{round(float(earning_agent)/float(money)*100,2)}%'
            # 󶨽ֳ
            earning_bind_coach=carIncomeScaleMap[sn]['earning_bind_coach']
            e_b=f'{round(float(earning_bind_coach)/float(money)*100,2)}%'
            # ¼ֳ
            earning_login_coach=carIncomeScaleMap[sn]['earning_login_coach']
            e_l=f'{round(float(earning_login_coach)/float(money)*100,2)}%'
            
        else:
            money=0
            earning_producer=0
            earning_agent=0
            earning_bind_coach=0
            earning_login_coach=0
            e_p='0%'
            e_a='0%'
            e_b='0%'
            e_l='0%'
     
        print(lc,seconds,money,earning_producer,date_bind_coach)
        
        ###############################
        # ׼
        # 
        _,endTime=time_convert('day')
        bindDay = time_diff(date_bind_coach,endTime)
        bindDay=1 if bindDay==0  else bindDay

        # ƽ̨վ
        adr=round(float(earning_producer)/float(bindDay),2)
        
        # վʹʱ(Сʱ)
        adut=round(float(seconds)/float(bindDay),2)
        
        # 뵥(Ԫ/Сʱ)
        upi=round(float(earning_producer)/float(bindDay),2)
      
        if seconds>0:
            # ѵָ(/Сʱ)
            ti=round(float(lc)/float(seconds),2)
        else:
            ti=0
    
        # 
        CarType=''
        # װ 0
        if bindDay<=7:
           CarType=0
           ckd_Num+=1 
           if bindDay==1:
               # 
                todayalltotal+=1  
        # 공 1
        elif adr>=6:
           CarType=1
           cbev_Num+=1
        # ʬ 2
        elif adr<0.6 and bindDay>=30:
            CarType=2
            av_Num+=1
        # ˯ 3
        elif adr<3.5 and adr>=0.6 and bindDay>=30 :
            CarType=3
            lsv_Num+=1
        # Ͳ 4
        else:
            CarType=4
            lcv_Num+=1
            
        # ͳƵȫϢ
        StatisticsAllInfo.append({
            'fdeviceid':sn,
            'brand':hphm,
            'school':companyName,
            'teacher':username,
            'banddate':date_bind_coach,
            'inc_total':money,
            'inc_kpl':earning_producer,
            'inc_server':earning_agent,
            'inc_teac':earning_bind_coach,
            'inc_teac2':earning_login_coach,
            'prop_kpl':e_p,
            'prop_serv':e_a,
            'prop_teac':e_b,
            'mileage':lc,
            'during':seconds,
            'ftype':CarType
        })
  
    ##########################################################         
    ##### ѭ
    print(ckd_Num,cbev_Num,av_Num,lsv_Num,lcv_Num) 
    
    
    # ckd_Ratio= f'{round(float(ckd_Num)/float(alltotal)*100,2)}%'
    # cbev_Ratio=f'{round(float(cbev_Num)/float(alltotal)*100,2)}%'
    # av_Ratio=f'{round(float(av_Num)/float(alltotal)*100,2)}%'
    # lsv_Ratio=f'{round(float(lsv_Num)/float(alltotal)*100,2)}%'
    # lcv_Ratio=f'{round(float(lcv_Num)/float(alltotal)*100,2)}%'
    
    # print(ckd_Ratio,cbev_Ratio,av_Ratio,lsv_Ratio,lcv_Ratio) 

    StatisticsOverview={
        'ftime':daytime,
        'ship':dev_total,
        'cap_total':alltotal,
        'cap_day':todayalltotal,
        'car_month':month_total,
        'car_day':day_total,
        'mber_total':stucoach_total,
        'mber_stud':coach_total,
        'mber_teac':stu_total,
        'order_total':all_ordersNum,
        'order_month':month_ordersNum,
        'order_day':day_ordersNum,
        'avg_total':car_output,
        'avg_kpl':kpl_car_output,
        'avg_serv':facilitator_car_output,
        'avg_teac':coach_car_output,
        'inc_total':day_income,
        'inc_kpl':day_kpl_income,
        'inc_serv':day_facilitator_income,
        'inc_teac':day_coach_income,
        'ini_vehicle':ckd_Num,
        'sta_vehicle':cbev_Num,
        'low_vehicle':lcv_Num,
        'sle_vehicle':lsv_Num,
        'frz_vehicle':av_Num,
        'vehicle_total':alltotal,
    }
    
    # Ϣ
    updata_server('baseinfo',{'list':StatisticsAllInfo})
    
    # ͳϢ
    updata_server('static',StatisticsOverview)